ifdef ACML
  ifndef ACML_PATH
    ACML_PATH=/opt/acml4.3.0
  endif
  ifdef ICC
    ifdef EM64T
      ifdef ILP64
        ACML_PATHL=$(ACML_PATH)/ifort64_int64/lib/
      else
        ACML_PATHL=$(ACML_PATH)/ifort64/lib/
      endif
    else
      ACML_PATHL=$(ACML_PATH)/ifort32/lib/
    endif
  else
    ifdef EM64T
      ifdef ILP64
        ACML_PATHL=$(ACML_PATH)/gfortran64_int64/lib/
      else
        ACML_PATHL=$(ACML_PATH)/gfortran64/lib/
      endif
    else
      ACML_PATHL=$(ACML_PATH)/gfortran32/lib/
    endif
  endif
  LIBS  += -lacml
  DLIBS += -lacml
  ifdef EM64T
    LIBS += -lacml_mv
    DLIBS += -lacml_mv
  endif
  COMMON_FLAGS += -DCVM_ACML=1
  COMMON_LD_FLAGS += -L$(ACML_PATHL) -Wl,-rpath,$(ACML_PATHL)
else 
ifdef ACML_MP
  ifndef ACML_PATH
    ACML_PATH=/opt/acml4.3.0
  endif
  ifdef ICC
    ifdef EM64T
      ifdef ILP64
        ACML_PATHL=$(ACML_PATH)/ifort64_mp_int64/lib/
      else
        ACML_PATHL=$(ACML_PATH)/ifort64_mp/lib/
      endif
    else
      ACML_PATHL=$(ACML_PATH)/ifort32_mp/lib/
    endif
  else
    ifdef EM64T
      ifdef ILP64
        ACML_PATHL=$(ACML_PATH)/gfortran64_mp_int64/lib/
      else
        ACML_PATHL=$(ACML_PATH)/gfortran64_mp/lib/
      endif
    else
      ACML_PATHL=$(ACML_PATH)/gfortran32_mp/lib/
    endif
  endif
  LIBS  += -lacml_mp
  DLIBS += -lacml_mp
  ifdef ICC
    LIBS  += -liomp5
    DLIBS += -liomp5
  endif
  ifdef EM64T
    LIBS += -lacml_mv
    DLIBS += -lacml_mv
  endif
  COMMON_FLAGS += -DCVM_ACML=1
  COMMON_LD_FLAGS += -L$(ACML_PATHL) -Wl,-rpath,$(ACML_PATHL)
else
ifdef MKL
  ifndef MKL_PATH
    MKL_PATH=/opt/intel/mkl/10.2.3.029/lib
  endif
  ifdef EM64T
    MKL_PATHL=$(MKL_PATH)/em64t
    MKL_LIBS  += -lmkl_core -liomp5
    ifdef ICC
      MKL_LIBS  += -lmkl_intel_thread
      ifdef ILP64
        MKL_LIBS  += -lmkl_intel_ilp64 
      else 
        MKL_LIBS  += -lmkl_intel_lp64
      endif
    else
      MKL_LIBS  += -lmkl_gnu_thread
      ifdef ILP64
        MKL_LIBS  += -lmkl_gf_ilp64 
      else 
        MKL_LIBS  += -lmkl_gf_lp64
      endif
    endif
  else
    MKL_PATHL=$(MKL_PATH)/32
    MKL_LIBS  += -lmkl_core -lmkl_lapack -lmkl_def -liomp5
    ifdef ICC
      MKL_LIBS  += -lmkl_intel_thread -lmkl_intel
    else
      MKL_LIBS  += -lmkl_gnu_thread -lmkl_gf
    endif
  endif
  COMMON_LD_FLAGS += -L$(MKL_PATHL) -Wl,-rpath,$(MKL_PATHL)
  LIBS  += $(MKL_LIBS)
  DLIBS += $(MKL_LIBS)
else
  LIBS  += $(call concat,-lblas,$(NF),$(NE),$(NI))
  LIBS  += $(call concat,-llapack,$(NF),$(NE),$(NI))
  DLIBS += $(call concat,-lblas,$(NF),$(NE),$(NI),_debug)
  DLIBS += $(call concat,-llapack,$(NF),$(NE),$(NI),_debug)
endif
endif
endif


